package outils;

import static org.junit.jupiter.api.Assertions.*;
import org.junit.jupiter.api.Test;

import java.util.Iterator;

public class TestListeTableauTriable {
	private boolean estEnOrdreCroissant(ListeTableau<Integer> lst) {
		Iterator<Integer> it = lst.iterator();
		Integer e1, e2;
		if (it.hasNext())
			e2 = it.next();
		else
			return true;
		while (it.hasNext()) {
			e1 = e2;
			e2 = it.next();
			if (e1.compareTo(e2) > 0)
				return false;
		}
		return true;
	}
    @SuppressWarnings("removal")
	@Test
    public void test01TriBulle() {
    	System.out.println("** test de tri qui devrait utiliser la stratégie de tri bulle **");
    	ListeTableauTriable<Integer> lst;
    	lst = new ListeTableauTriable<Integer>();
    	int i;
    	for (i = 1; i <= 1000; i++) {
    		if (Math.random() > 0.8)
    			lst.ajoute(new Integer((int) Math.round(100 * Math.random())));
    		else
    			lst.ajoute(new Integer(i));
    	}
    	lst.trie();
    	assertTrue(estEnOrdreCroissant(lst));
    }
    @SuppressWarnings("removal")
    @Test
    public void test02TriSelection() {
    	System.out.println("** test de tri qui devrait utiliser la stratégie de tri sélection **");
    	ListeTableauTriable<Integer> lst;
    	lst = new ListeTableauTriable<Integer>();
    	int i;
    	for (i = 1000; i > 0; i--) lst.ajoute(new Integer(i));
    	lst.trie();
    	assertTrue(estEnOrdreCroissant(lst));
    }
}
